<template>
  <div>
    <div
      v-if="!isNew"
      class="row"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="dataSource.eventData && dataSource.eventData.occurredAt"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="dataSource.eventData && dataSource.eventData.authorTitle"
          :readonly="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ObTextarea
          :value="formData.eventData && formData.eventData.comment"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="(!isNew && !isNewForm)"
          @input="onChangeField('eventData.comment', $event)"
        />
      </div>
    </div>
    <template v-if="formData.eventData && (!formData.eventData.fileUuids || !formData.eventData.fileUuids.length) && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="(formData.eventData && formData.eventData.fileUuids && formData.eventData.fileUuids.length) || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="(!isNew && !isNewForm)"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObInput from 'common-components/src/obComponents/obInput'

export default {
  name: 'defaultEventForm',
  components: {
    ObTextarea,
    ObUploader,
    ObDatePickerConstructor,
    ObInput
  },
  props: {
    formData: {
      type: Object,
      default: () => {
        return {
          eventData: {},
          specialParameters: {}
        }
      }
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    }
  },
  watch: {
    'formData.eventData.fileUuids'(value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource.filesData
    }
  },
  methods: {
    startUploadFiles () {
      this.formData.eventData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField('eventData.fileUuids', null)
        return
      }

      this.onChangeField('eventData.fileUuids', data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    }
  }
}
</script>